import greenfoot.*;  // (World, Actor, GreenfootImage, Greenfoot and MouseInfo)
import java.awt.Color;

/**
 * Write a description of class world here.
 * 
 * @author (your name) 
 * @version (a version number or a date)
 */
public class world extends World
{
    boolean[][] world = new boolean[500][500];
    int scale = 1;
    int x = 0;
    int y = 0;
    boolean play = true;
    /**
     * Constructor for objects of class world.
     * 
     */
    public world()
    {    
        // Create a new world with 600x400 cells with a cell size of 1x1 pixels.
        super(500, 500, 1); 
        randomize();
        draw();
    }
    public void randomize()
    {
        for(int i=0;i<500;i++)
        for(int j=0;j<500;j++)
            world[i][j] = false;
        for(int i=0;i<500;i++)
        for(int j=0;j<500;j++)
            if(Math.random()<.2)world[i][j] = true;
    }
    public void act()
    {
        int around = 0;
        boolean[][] world2 = new boolean[500][500];
        if(play)
        for(int i=1;i<499;i++)
        for(int j=1;j<499;j++)
        {
            around = 0;
            if(world[i+1][j])around++;
            if(world[i-1][j])around++;
            if(world[i][j+1])around++;
            if(world[i][j-1])around++;
            if(world[i+1][j-1])around++;
            if(world[i+1][j+1])around++;
            if(world[i-1][j+1])around++;
            if(world[i-1][j-1])around++;
            if(around<2||around>3)
                world2[i][j]=false;
            else if(around==3)world2[i][j] = true;
            else world2[i][j] = world[i][j];
        }
        world = world2;
        if(Greenfoot.isKeyDown("r"))
            randomize();
        if(Greenfoot.mouseClicked(null))
        {
            MouseInfo m = Greenfoot.getMouseInfo();
            if(m.getButton()==1&&scale<3){
                scale++;
                x = x + m.getX()/scale;
                y = y + m.getY()/scale;
            }
            else if(scale>1)
            {
                x = x - m.getX()/scale;
                y = y - m.getY()/scale;
                scale--;
            }
        }
        try{draw();}catch(ArrayIndexOutOfBoundsException e){}
    }
    public void draw()
    {
        Color black = Color.black;
        GreenfootImage b = getBackground();
        b.setColor(Color.white);
        b.fill();
        for(int i=0;i<500;i++)
        for(int j=0;j<500;j++)
            if(world[x+i/scale][y+j/scale])b.setColorAt(i,j,black);
        b.setColor(Color.black);
        b.drawString("scale: "+scale,20,20);
    }
}
